#!/usr/bin/perl -w

# TODO: also add the marker word to main-id.hex :0237FE005AA5CA
# and add some more robust 'S' flood to prog.pl (bootl_sync now uses 'p' ?)
# Or, do the proper thing, and put some
# (preferrably non-FF code, but FF is not a big problem either) on the marker page, and
# have crypto make a markerless marker page (that prog.pl uploads outoforder at the start)
# and than the normal markered marker page (uploaded normally at the end)

#patches the bootloaders hex file with identification data

my $serial = $ARGV[0]; # 1..65535

# 0 is not valid in upper byte:
$serial += 256;

my $sh = $serial >> 8;
my $sl = $serial & 0xFF;

if( $sh==0 || $sh==0xff ){
	print STDERR "Warning: 0 or 0xFF in the serial nr high byte (changed to 1)\n";
	$sh = 1;
}

if( $sl==0 || $sl==0xff ){
	print STDERR "ERROR: 0 or 0xFF in the serial nr low byte (changed to 1)\n";
	$sl = 1; 	
}

my $srl =  sprintf("%02x%02x", $sh, $sl);
print STDERR "identity serial_internal=0x$srl\n" ;

$identity->[0] = ord('r');
$identity->[1] = ord('0');
$identity->[2] = ord('.');
$identity->[3] = ord('0');
$identity->[4] = 0;
$identity->[5] = 0;
$identity->[6] = 0;
$identity->[7] = 0;
$identity->[8] = 1;
$identity->[9] = 1;
$identity->[10] = $sh;
$identity->[11] = $sl;


sub identity
{
	my $i = shift;
	return $identity->[$i];
}


# hmm.. no match /^:0CFFF000(\w+)/ ... $ tail boot\main.hex
#:10FF40005F926F927F928F929F92AF92BF92CF9269
#:10FF5000DF92EF92FF920F931F93CF93DF93CDB772
#:10FF6000DEB7CA1BDB0B0FB6F894DEBF0FBECDBFEA
#:10FF700009942A88398848885F846E847D848C84BB
#:10FF80009B84AA84B984C884DF80EE80FD800C81C4
#:10FF90001B81AA81B981CE0FD11D0FB6F894DEBFA7
#:08FFA0000FBECDBFED01089575
#:04FFFC000C9400FC65
#:040000031000F800F1
#:00000001FF

while(<STDIN>) {

    if (/^:0C3FF000(\w+)/) {
	my $data=$1;
	if ($data =~ /0{24}C5/) { # good, array is 12bytes of zero as expected
	    print ":0C3FF000";
	    # split string into bytes and calculate checksum
	    my $chksum = hex("0c") + hex("3f") + hex("f0"); #+ hex(00)
	    for (my $i=0; $i<12; $i++) {
		my $val = identity($i);
		$chksum += $val;
		printf("%02X", $val);
	    }
	    $chksum = 256 - ($chksum % 256);  # sum of all hex bytes must be zero
	    $chksum = $chksum % 256;
	    printf("%02X\n", $chksum);
	} else {
	    print STDERR "ERROR: The identity array already contains data, maybe the bootloader code overlaps? Check it!\n";
	    exit -1;
	}
    } else {
	print $_;
    }
}

exit 0;
